"use strict";
var app = function() {
	var connection;
	var loc;
	var map;
	var mapCanvasId = 'map_canvas';
	var $mapCanvas;
	var markers = [];
	var markersIdx = 0;
	var positionWatcher;
	var mapDiv;
	var distance;
	var line;
	var infoWindows = [];
	var startTime;
	var intPtr;
	var circles = [];
	// this indicates if data packaging warning was already displayed
	var warningShown = false;
	var coords; // map center coords
	return {

		extendJQMobile : function() {
			$.extend($.mobile, {
				defaultPageTransition : "flip",
				loadingMessageTextVisible : true,
				pageLoadErrorMessage : i18nLang.get('unableToLoad'),
				pageLoadErrorMessageTheme : "b",
				touchOverflowEnabled : true,
				loadingMessage : i18nLang.get('pleaseWait'),
				allowCrossDomainPages : true,
				ajaxEnabled : false
			});
		},

		initialize : function() {
			if (!config.desktop) {
				document.addEventListener("deviceready", app.onDeviceReady, false);
			} else {
				$(document).on("pageinit", '#main', app.onDeviceReady);
			}
		},
		extendGoogleClasses : function() {
			google.maps.LatLng.prototype.accuracy = 0;
		},
		markersToPositions : function() {
			var positions = [];
			for ( var i = 0; i < markers.length; i++) {
				positions.push(markers[i].position);
			}
			return positions;
		},
		onDeviceReady : function() {
			console.log("onDeviceReady");
			console.log("config.desktop -> " + config.desktop);
			view.bindHomePageUrl();
			$mapCanvas = $('#' + mapCanvasId);
			i18n.localizationInit(function() {
				console.log("Internet available");
				facebookAds.init();
				facebookAds.requestInterstitial();
				view.loader(true);
				i18nLang.init();
				app.extendJQMobile();
				i18nLang.translateStaticUI();
				view.setUIControl({
					name : 'numberOfPoints',
					value : i18nLang.get('points') + markers.length
				});
				app.checkConnection(function() {
					/**
					 * Calculates the area /
					 */
					var calculateArea = function(recalculateAfterUnitChanged) {
						if (typeof analytics !== "undefined")
							analytics.trackEvent('Calculate', 'Area');
						if (!recalculateAfterUnitChanged && markers.length <= 2) {
							view.showPopup(i18nLang.get('pleaseStore'));
							return false;
						}

						// in case of recalculation and if no initial
						// calculation was done
						// do not calculate
						if (recalculateAfterUnitChanged && !line) {
							view.setUIControl({
								name : 'distance',
								value : i18n.unitTransformationArea(0)
							});
							return false;
						}

						app.cancelLocationCheck();
						var positions = app.markersToPositions();
						var markersPosId = app.markersToPositionsIds();
						distance = google.maps.geometry.spherical.computeArea(positions);
						var result = dm.resultUnits[settings.get(settings.types.units)]['area'][(distance / dm.resultUnits[settings.get(settings.types.units)]['area'][1].divider >= 1) + 0]
						var area = view.round(distance / result.divider);
						view.setUIControl({
							name : 'distance',
							value : area + result.unit + '^' + result.sup
						});
						if (line)
							line.setMap(null);
						line = new google.maps.Polygon({
							path : positions,
							strokeColor : '#FF0000',
							strokeOpacity : 1.0,
							strokeWeight : 2.5,
							fillColor : "#FF0000",
							fillOpacity : 0.4
						});
						line.setMap(map);
						var measurement = new dm.models.Measurement({
							unit : result.unit + '^' + result.sup,
							type : 'area',
							result : area,
							locations : markersPosId.ids
						});
						if (!!distance)
							measurement.save();
					}
					settings.init(function() {
						app.closeInfoWindows();
						calculateArea(true);
					});
					settings.set(settings.types.units, (i18n.getMetricSystem() === 'IMPERIAL') ? 'miles' : 'meters');
					view.setUIControl({
						name : 'distance',
						value : i18n.unitTransformationArea(0)
					});
                    dm.innerLoader.load();
					view.loader(false);
					services.googleAnalytics(function() {
						services.googleAPIs(function() {
							app.extendGoogleClasses();
							view.showSettings(true);
							coords = i18n.getCountryCoords();
							console.log("Locale -> " + i18n.getLocale().locale);
							console.log("Lang -> " + i18n.getLocale().lang);
							var mapOptions = {
								center : new google.maps.LatLng(coords.center[0], coords.center[1]),
								zoom : coords.zoom,
								mapTypeId : google.maps.MapTypeId.HYBRID,
								streetViewControl : false,
								mapTypeControl : false,
								zoomControl : true,
								zoomControlOptions : {
									style : google.maps.ZoomControlStyle.SMALL,
									position : google.maps.ControlPosition.LEFT_CENTER
								},
								panControl : false
							};
							mapDiv = document.getElementById(mapCanvasId);
							map = new google.maps.Map(mapDiv, mapOptions);
							google.maps.event.addListener(map, 'bounds_changed', function() {
								app.checkConnection(function() {
								}, function() {
									view.showPopup(i18nLang.get('needInternet'));
								});
							});
							google.maps.event.addListenerOnce(map, 'idle', function() {
								console.log("Map idle");
								services.adSence(app.initPopupHandler);
								app.fixAndroidLine();
							});
							$('#store').on('click', function() {
								app.checkLocationAndSetMarker();
							});
							$('#calcDist').on('click', function(e) {
								var callback = function() {
									e.preventDefault();
									calculateArea(false);
								}
								facebookAds.showInterstitial(callback.bind(this));
							});
							$('#clear').on('click', function() {
								app.clear();
							});
						}, app);
					});
				}, function() {
					view.showPopup(i18nLang.get('needInternetExtended'));
				});
			});
		},

        /**
         * Handles commercial startup popup /
         */
        initPopupHandler : function() {
            if (i18n.getLocale().lang === "en" && typeof configRemote !== "undefined" && configRemote.get('showPromo')) {
                var initPopupModel = new dm.models.initPopup();
                var initPopup = function(model) {
                    var initPopupView = new dm.views.InitPopup({
                        model : model
                    });
                    if (!model.get('notShow'))
                        initPopupView.render();
                }
                initPopupModel.fetch({
                    success : initPopup,
                    error : initPopup
                });
            }
        },

		/**
		 * Temporary disabled /
		 */
		checkIfConnCellular : function() {
			if (navigator.connection && navigator.connection.type) {
				var connection = navigator.connection.type;
				if (!warningShown && (connection === Connection.CELL_2G || connection === Connection.CELL_3G || connection === Connection.CELL_4G || connection === Connection.CELL)) {
					view.showPopup("Please consider that application may incure additional costs 2G/3G/4G connection.");
					warningShown = true;
				}
			}
		},
		/**
		 * Android back button handler - used only while position acquisition is
		 * in progress. /
		 */
		bindBackButton : function(add) {
			if (add)
				document.addEventListener("backbutton", app.cancelLocationCheck, false);
			else
				document.removeEventListener("backbutton", app.cancelLocationCheck, false);
		},
		checkConnection : function(success, error) {
			console.log("checkConnection");
			if (typeof error !== "function" || typeof success !== "function") {
				console.error("Error while checking the connection!");
				return false;
			}
			if (config.desktop) {
				console.log("No navigator.connection -> assume desktop browser");
				success();
				return false;
			}
			connection = navigator.connection.type;
			if ((connection === Connection.NONE || connection === Connection.UNKNOWN)) {
				console.log("No Internet connection");
				error();
			} else {
				console.log("Internet connection available | type -> " + connection);
				success();
			}
		},
		getConnection : function() {
			return connection;
		},
		getLocation : function() {
			return location;
		},
		removeMarkers : function() {
			for ( var i = 0; i < markers.length; i++)
				markers[i].setMap(null);
			if (line)
				line.setMap(null);
		},
		removeCircles : function() {
			for ( var i = 0; i < circles.length; i++)
				circles[i].setMap(null);
		},
		removeCircle : function(circle) {
			circle.setMap(null);
		},
		removeMarker : function(markerIdx) {
			var callback = function() {
				if (markers[markerIdx])
					markers[markerIdx].setMap(null);
				if (line)
					line.setMap(null);
				view.setUIControl({
					name : 'distance',
					value : i18n.unitTransformationArea(0)
				});
				markers.splice(markerIdx, 1);
				markersIdx = markers.length;
				view.setUIControl({
					name : 'numberOfPoints',
					value : i18nLang.get('points') + markers.length
				});
				this.removeCircle(circles[markerIdx]);
				for ( var i = 0; i < markers.length; i++) {
					this.updateEventsForMarker(i);
				}
			}
			facebookAds.showInterstitial(callback.bind(this));
		},
		stopCheckingLocation : function() {
			navigator.geolocation.clearWatch(positionWatcher);
		},
		closeInfoWindows : function() {
			for ( var i = 0; i < infoWindows.length; i++)
				if (infoWindows[i])
					infoWindows[i].close();
		},
		clear : function() {
			var callback = function() {
				this.cancelLocationCheck();
				this.closeInfoWindows();
				this.removeMarkers();
				this.removeCircles();
				view.setUIControl({
					name: 'distance',
					value: i18n.unitTransformationArea(0)
				});
				view.setUIControl({
					name: 'numberOfPoints',
					value: i18nLang.get('points') + ' 0'
				});
				markers = [];
				markersIdx = 0;
				view.updateControlButton(markers);
				if (coords) {
					map.panTo(new google.maps.LatLng(coords.center[0], coords.center[1]));
					map.setZoom(coords.zoom);
				}
			}
			facebookAds.showInterstitial(callback.bind(this));
		},
		checkLocationAndSetMarker : function() {
			var that = this;
			this.stopCheckingLocation();
			this.checkLocation(function() {
				that.closeInfoWindows();
				markers[markersIdx] = new google.maps.Marker({
					position : loc,
					map : map,
					draggable : true
				});
				// create new location object to send it to the server
				var location = new dm.models.Location({
					lat : loc.lat(),
					lng : loc.lng()
				});
				var currentIdx = markersIdx;
				location.save(null, {
					success : function(model) {
						markers[currentIdx].id = model.get('id')
					}
				});
				view.updateControlButton(markers);
				view.setUIControl({
					name : 'numberOfPoints',
					value : i18nLang.get('points') + markers.length
				});
				circles[markersIdx] = new google.maps.Circle({
					map : map,
					radius : loc.accuracy,
					strokeColor : "#FF0000",
					strokeOpacity : 0.25,
					strokeWeight : 1.5,
					fillColor : "#FF0000",
					fillOpacity : 0.15,
				});
				circles[markersIdx].bindTo('center', markers[markersIdx], 'position');
				infoWindows[markersIdx] = new google.maps.InfoWindow({
					content : that.markerDesc(markersIdx),
					maxWidth : 100,
				});
				that.updateEventsForMarker(markersIdx);
				// for 2 markers or more fit the map
				if (markers.length >= 2) {
					that.fitMapToMarkers();
				} else {
					map.panTo(loc);
					map.setZoom(14);
				}
				that.stopCheckingLocation();
				markersIdx++;
			}, function() {
				view.showPopup(i18nLang.get('unableToDetermine', {
					accuracy : i18n.unitTransformationMeters(120)
				}));
			});
		},
		updateEventsForMarker : function(markerIdx) {
			var that = this;
			google.maps.event.clearListeners(markers[markerIdx], 'click');
			google.maps.event.addListener(markers[markerIdx], 'click', function() {
				infoWindows[markerIdx].setContent(that.markerDesc(markerIdx));
				infoWindows[markerIdx].open(map, markers[markerIdx]);
			});
			google.maps.event.addListener(markers[markerIdx], 'dragstart', function() {
				app.getMap().setOptions({
					draggable : false
				});
			});
			google.maps.event.clearListeners(markers[markerIdx], 'dragend');
			google.maps.event.addListener(markers[markerIdx], 'dragend', function() {
				setTimeout(function() {
					app.getMap().setOptions({
						draggable : true
					});
				}, 0);
				var location = new dm.models.Location({
					lat : markers[markerIdx].position.lat(),
					lng : markers[markerIdx].position.lng()
				});
				location.save(null, {
					success : function(model) {
						markers[markerIdx].id = model.get('id');
						app.fixAndroidLine();
					}
				});
				infoWindows[markerIdx].setContent(that.markerDesc(markerIdx));
				if (line)
					line.setMap(null);
				view.setUIControl({
					name : 'distance',
					value : i18n.unitTransformationArea(0)
				});
			});
			google.maps.event.clearListeners(infoWindows[markerIdx], 'domready');
			google.maps.event.addListener(infoWindows[markerIdx], 'domready', function() {
				$('#markerRemove_' + markerIdx).on('click', function() {
					that.closeInfoWindows();
					that.removeMarker(markerIdx);
					app.fixAndroidLine();
				});
			});
		},
		markerDesc : function(markerIdx) {
			var msg = i18nLang.get('position') + ' ' + markerIdx + "<br />";
			msg += "<a href='#' id='markerRemove_" + markerIdx + "'>" + i18nLang.get('remove') + "</a><br />"
			msg += i18nLang.get('lat') + view.round(markers[markerIdx].position.lat()) + "<br />" + i18nLang.get('lng') + view.round(markers[markerIdx].position.lng()) + "<br />" + i18nLang.get('accuracy') + i18n.unitTransformationMeters(markers[markerIdx].position.accuracy);
			return msg;
		},
		fitMapToMarkers : function(loc) {
			var bounds = new google.maps.LatLngBounds();
			for ( var i = 0; i < markers.length; i++) {
				if (markers[i])
					bounds.extend(markers[i].position);
			}
			map.fitBounds(bounds);
		},
		cancelLocationCheck : function() {
			view.loader(false);
			clearInterval(intPtr);
			navigator.geolocation.clearWatch(positionWatcher);
			app.bindBackButton(false);
		},
		markersToPositionsIds : function() {
			var ret = {
				positions : [],
				ids : []
			}
			for ( var i = 0; i < markers.length; i++) {
				ret.positions.push(markers[i].position);
				ret.ids.push(markers[i].id);
			}
			return ret;
		},
		fixAndroidLine : function() {
			if (app.isMobile()) {
				var oldZoom = _.clone(map.getZoom());
				map.setZoom(oldZoom + 1);
				map.setZoom(oldZoom);
			}
		},
		checkLocation : function(success, error) {
			console.log("checkLocation");
			var that = this;
			if (typeof error !== "function" || typeof success !== "function") {
				console.error("Error while checking the location!");
				return false;
			}
			this.cancelLocationCheck();
			app.bindBackButton(true);
			view.loader(true);
			startTime = new Date();
			intPtr = setInterval(function() {
				var now = new Date();
				if (now - startTime > config.locationTimeout * 1000) {
					app.cancelLocationCheck();
					error();
				}
			}, 750);
			positionWatcher = navigator.geolocation.watchPosition(function(location) {
                var now = new Date();
                var timePassed = (now - startTime) / 1000;
                var minAcc = (timePassed > 10) ? 11 * timePassed - 100 : config.minAccuracyFor10Sec;
				if (!config.definedCoords) {
					loc = new google.maps.LatLng(location.coords.latitude, location.coords.longitude);
					loc.accuracy = location.coords.accuracy;
                    /**
                     * In case of desktop browser no accuracy taken into account.
                     */
                    if (!app.isMobile() || loc.accuracy < minAcc) {
                        app.cancelLocationCheck();
                        success();
                    }
				} else {
					// test data
                    var location = locationProvider.getLocation();
                    loc = new google.maps.LatLng(location.lat, location.lng);
                    loc.accuracy = location.acc;
                    setTimeout(function() {
                        if (loc.accuracy < minAcc) {
                            app.cancelLocationCheck();
                            success();
                        } else {
                            locationProvider.back();
                        }
                    }, 2000);
				}
			}, function(geoError) {
				var posError = 'navigator.geolocation.watchPosition error -> ' + ((geoError && geoError.message) ? geoError.message : 'unknown');
				console.error(posError);
				app.cancelLocationCheck();
				error();
			}, {
				maximumAge : 0,
				timeout : config.minAccuracyFor10Sec * 1000,
				enableHighAccuracy : true
			});
		},
		isMobile : function() {
			return navigator.userAgent.match(/(iPhone|iPod|iPad|Android|BlackBerry|Tizen)/);
		},
        isFirefox : function() {
            return !!navigator.userAgent.match(/(Firefox)/);
        },
		getMap : function() {
			return map;
		}
	}
}();
