"use strict";
var i18nLang = function() {
	var langCode = 'en'; // default language
	var getString = function(element, values) {
		if (lang[element] && typeof lang[element] === "string")
			var template = _.template(lang[element]);
		else {
			var template = _.template(element);
			console.error("Unable to find translation for -> " + element);
		}
		return template((values) ? values : {});
	};
	
	var getExactLangElement = function(element) {
		if (lang[element] ) {
			return lang[element];
		} else {
			console.error("Unable to find element -> " + element);
		}
	}

	var getLanguageFile = function() {
		var locale = i18n.getLocale();
		if (locale.lang) {
			langCode = locale.lang;
		}
		$.ajaxSetup({
			async : false
		});
		$.getScript("./js/langs/" + langCode + '.js', function(data, textStatus) {
			if (textStatus !== "success") {
				view.showPopup("Unable to load language file. Please restart the application, as it will not work properly.");
				return false;
			}
		});
		$.ajaxSetup({
			async : true
		});
	};

	var translateStaticUI = function() {
		view.updateButtonText($('#store'), getString('startPoint'));
		view.updateButtonText($('#calcDist'), getString('calcDistance'));
		view.updateButtonText($('#clear'), getString('clear'));
		view.updateButtonText($('#about'), getString('settings'));
		$('#main').attr('data-title', i18nLang.get('appName'));
		$('.about-t').text(getString('about'));
		$('.units-t').text(getString('units'));
		$('#milesL').text(getString('milesD'));
		$('#metersL').text(getString('meters'));
		$('#about-b').text(getString('about'));
		$('.close-btn').text(getString('close'));
		$('#how').text(getString('how'));
		$('#how-desc').text(getString('howDesc'));
		$('#how-to-read').text(getString('howToRead'));
		fillOl($('#how-to-read-det'), getExactLangElement('howToReadPoints'));
		fillOl($('#additional-det'), getExactLangElement('additionalPoints'));
		$('#additional').text(getString('additional'));
		$('#questions').text(getString('questions'));
		$('#onlyEng').text(getString('onlyEng'));
	};

	var fillOl = function(list, elements) {
		for ( var i = 0; i < elements.length; i++) {
			list.append(_.template('<li><%= el %></li>', {
				el : elements[i]
			}))
		}
	};

	var displayAll = function(lang) {
		for(var key in lang) {
			if(typeof lang[key] === "object") {
				displayAll(lang[key]);
			} else {
				console.log(lang[key]);
			}
		}
	};
	
	return {
		get : getString,
		init : getLanguageFile,
		translateStaticUI : translateStaticUI,
		show : function() {
			console.log('------------');
			console.log('LANG -> ' + i18n.getLocale().lang);
			console.log('------------');
			displayAll(lang);
			console.log('------------');
		}
	};
}();