"use strict";
var settings = function() {

	var TYPES = {
		units : "units"
	}

	/**
	 * Units const
	 */
	var UNITS = {
		meters : "meters",
		miles : 'miles'
	}

	/**
	 *
	 * Default settings
	 */
	var settings = {
		units : UNITS.meters
	}

	var isLocalStorage = true;
	var callback = null;

	var check = function() {
		if (typeof localStorage === "undefined") {
			console.error("No localStorage");
			$(".control-g").hide();
			isLocalStorage = false;
			return false;
		}
		return true;
	}

	var handler = function() {
		if ($(this).prop("value") === UNITS.meters) {
			settings = {units : UNITS.meters};
		} else {
			settings = {units : UNITS.miles};
		}
		if (callback) {
			callback();
		}
		save();
	}

	var select = function(type, value) {
		$("input[value='" + value + "']").prop("checked", true);
	}

	var init = function(callbackUnits) {
		if (!check())
			return false;
		callback = callbackUnits;
		$("input[name='units']").on("click", handler);
	}

	var save = function() {
		localStorage.setItem("settings", JSON.stringify(settings));
	}

	var load = function() {
		if (localStorage.getItem("settings")) {
			settings = JSON.parse(localStorage.getItem("settings"));
			return true;
		}
		return false;
	}

	return {
		init : init,
		types : TYPES,
		get : function(type) {
			switch (type) {
			case TYPES.units:
				return settings.units
			}
		},
		set : function(type, value) {
			// If loaded from localStrage do not take from function parameters
			if (load()) {
				switch (type) {
				case TYPES.units: {
					select(type, settings[type]);
				}
				}
				return false;
			}
			switch (type) {
			case TYPES.units: {
				select(type, value);
				settings[TYPES.units] = value;
				save();
			}
			}
		}
	}
}();