"use strict";
var view = function() {

	return {
		showPopup : function(msg) {
			console.log(msg);
			$($.mobile.activePage).find('.popup p').html(msg);
			$($.mobile.activePage).find('.popup').popup("open");
		},
		loader : function(show) {
			if (show)
				$.mobile.loading('show', {
					theme : "b",
				});
			else
				$.mobile.loading('hide');
			this.showSettings(!show);
			this.disableTopUI(show);
		},
		setUIControl : function(control) {
			$('#' + control.name).html(control.value);
		},
		updateControlButton: function(markers) {
			if (markers.length === 0) {
				this.updateButtonText($('#store'), i18nLang.get('startPoint'));
			} else {
				this.updateButtonText($('#store'), i18nLang.get('nextPoint'));
			}
		},
		getStreenHeight : function() {
			return $(window).height();
		},
		showSettings : function(show) {
			if (show)
				$('#aboutContent').show();
			else
				$('#aboutContent').hide();
		},
		disableTopUI : function(disable) {
			if(disable)
				$('.headerMask').show();
			else 
				$('.headerMask').hide();
		},
		openUrl : function(url) {
			window.open(url, '_blank', 'location=yes');
		},
		bindHomePageUrl : function() {
			var that = this;
			$('#home_page').bind('click', function() {
				var supportURL = 'http://mobilenext.scislo.eu/mobile/area-meter';
				that.openUrl(supportURL);
			})
		},
		/**
		 * Rounds number to 4 digits after comma
		 */
		round : function(val) {
			if (typeof val !== "number")
				return val;
			return Math.round(val * 10000) / 10000;
		},
		
		updateButtonText : function(btn, text) {
			$(btn).find('.ui-btn-text').text(text);
		},
	};
}();