"use strict";
dm.views.Parent = Backbone.View.extend({
	templateCache : [],
	getTemplate : function() {
		if (typeof this.templateName === "undefined") {
			var msg = "No this.templateName defined";
			console.error(msg);
			return false;
		}
		var that = this;
		if (dm.views.Parent.prototype.templateCache[that.templateName]) {
			this.template = _.template(dm.views.Parent.prototype.templateCache[that.templateName]);
			return true;
		}
		$.ajax({
			async : false,
			url : './templates/' + this.templateName + '.html',
			success : function(response) {
				that.template = _.template(response);
				dm.views.Parent.prototype.templateCache[that.templateName] = response;
			},
			error : function() {
				var msg = "Failed to load template: " + that.templateName;
				console.error(msg);
			}
		});
	},

    initialize : function() {
        this._super();
        this.modelBinder = new Backbone.ModelBinder();
        this.getTemplate();
    }
});